Attribute VB_Name = "modExpressions"
Option Explicit

Sub Expression(Comienzo As Long, Optional ByVal Parenthesis As Boolean)
  SemiExpression Comienzo
  ToFileInt 10801
End Sub

Private Sub SemiExpression(Comienzo As Long)
  SubExpression Comienzo
  Do
    Select Case Palabra(Comienzo)
      Case "="
        ToFileInt 10010
      Case ">"
        Select Case Palabra(Comienzo + 1)
          Case "="
            ToFileInt 10050
            Comienzo = Comienzo + 1
          Case Else
            ToFileInt 10030
        End Select
      Case "<"
        Select Case Palabra(Comienzo + 1)
          Case "="
            ToFileInt 10060
            Comienzo = Comienzo + 1
          Case ">"
            ToFileInt 10020
            Comienzo = Comienzo + 1
          Case Else
            ToFileInt 10040
        End Select
      Case Else
        Exit Sub
    End Select
    Comienzo = Comienzo + 1
    SubExpression Comienzo
  Loop
End Sub

Private Sub SubExpression(Comienzo As Long)
  XorExpression Comienzo
  Do
    Select Case Palabra(Comienzo)
      Case "+"
        ToFileInt 10100
        Comienzo = Comienzo + 1
        XorExpression Comienzo
      Case "-"
        ToFileInt 10111
        Comienzo = Comienzo + 1
        XorExpression Comienzo
      Case Else
        Exit Do
    End Select
  Loop
End Sub

Private Sub XorExpression(Comienzo As Long)
  OrExpression Comienzo
  Do
    Select Case LCase$(Palabra(Comienzo))
      Case "xor"
        ToFileInt 10301
        Comienzo = Comienzo + 1
        OrExpression Comienzo
      Case Else
        Exit Do
    End Select
  Loop
End Sub

Private Sub OrExpression(Comienzo As Long)
  AndExpression Comienzo
  Do
    Select Case LCase$(Palabra(Comienzo))
      Case "or"
        ToFileInt 10501
        Comienzo = Comienzo + 1
        AndExpression Comienzo
      Case Else
        Exit Do
    End Select
  Loop
End Sub

Private Sub AndExpression(Comienzo As Long)
  TermExpression Comienzo
  Do
    Select Case LCase$(Palabra(Comienzo))
      Case "and"
        ToFileInt 10601
        Comienzo = Comienzo + 1
        TermExpression Comienzo
      Case Else
        Exit Do
    End Select
  Loop
End Sub

Private Sub TermExpression(Comienzo As Long)
  OtherExpression Comienzo
  Do
    Select Case LCase$(Palabra(Comienzo))
      Case "*"
        ToFileInt 10701
        Comienzo = Comienzo + 1
        OtherExpression Comienzo
      Case "/"
        ToFileInt 10711
        Comienzo = Comienzo + 1
        OtherExpression Comienzo
      Case "\"
        ToFileInt 10721
        Comienzo = Comienzo + 1
        OtherExpression Comienzo
      Case Else
        Exit Do
    End Select
  Loop
End Sub

Private Sub OtherExpression(Comienzo As Long)
  FactorExpression Comienzo
  Do
    Select Case LCase$(Palabra(Comienzo))
      Case "shl"
        ToFileInt 10731
        Comienzo = Comienzo + 1
        FactorExpression Comienzo
      Case "shr"
        ToFileInt 10741
        Comienzo = Comienzo + 1
        FactorExpression Comienzo
      Case "^"
        ToFileInt 10751
        Comienzo = Comienzo + 1
        FactorExpression Comienzo
      Case Else
        Exit Do
    End Select
  Loop
End Sub

Private Sub FactorExpression(Comienzo As Long)
  Dim Limite As Long

  Select Case LCase$(Palabra(Comienzo))
    Case "("
      ToFileInt 10800
      Comienzo = Comienzo + 1
      Expression Comienzo, True
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "-"
      ToFileInt 10112
      Comienzo = Comienzo + 1
      FactorExpression Comienzo
      Exit Sub
    Case "+"
      Comienzo = Comienzo + 1
      FactorExpression Comienzo
      Exit Sub
    Case "not"
      ToFileInt 10300
      Comienzo = Comienzo + 1
      FactorExpression Comienzo
      Exit Sub
    Case "lcase"
      ToFileInt 15100
      If Palabra(Comienzo + 1) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 2
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "ucase"
      ToFileInt 15110
      If Palabra(Comienzo + 1) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 2
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "mid"
      ToFileInt 15120
      If Palabra(Comienzo + 1) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 2
      Expression Comienzo
      If Palabra(Comienzo) <> "," Then AddError 23, False, "','"
      Comienzo = Comienzo + 1
      Expression Comienzo
      If Palabra(Comienzo) <> "," Then AddError 23, False, "','"
      Comienzo = Comienzo + 1
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "str"
      ToFileInt 15130
      If Palabra(Comienzo + 1) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 2
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "val"
      ToFileInt 15140
      If Palabra(Comienzo + 1) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 2
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "left"
      ToFileInt 15160
      If Palabra(Comienzo + 1) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 2
      Expression Comienzo
      If Palabra(Comienzo) <> "," Then AddError 23, False, "','"
      Comienzo = Comienzo + 1
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "right"
      ToFileInt 15170
      If Palabra(Comienzo + 1) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 2
      Expression Comienzo
      If Palabra(Comienzo) <> "," Then AddError 23, False, "','"
      Comienzo = Comienzo + 1
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "chr"
      ToFileInt 15190
      If Palabra(Comienzo + 1) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 2
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "true"
      ToFileInt 15200
    Case "false"
      ToFileInt 15201
    Case "eventid"
      ToFileInt 15210
    Case "message"
      ToFileInt 15220
      Comienzo = Comienzo + 1
      If Palabra(Comienzo) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 1
      Expression Comienzo
      If Palabra(Comienzo) <> "," Then AddError 23, False, "','"
      Comienzo = Comienzo + 1
      Expression Comienzo
      If Palabra(Comienzo) <> "," Then AddError 23, False, "','"
      Comienzo = Comienzo + 1
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "len"
      ToFileInt 15230
      If Palabra(Comienzo + 1) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 2
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "instr"
      ToFileInt 15240
      If Palabra(Comienzo + 1) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 2
      Expression Comienzo
      If Palabra(Comienzo) <> "," Then AddError 23, False, "','"
      Comienzo = Comienzo + 1
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "rnd"
      ToFileInt 15250
      If Palabra(Comienzo + 1) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 2
      Expression Comienzo
      If Palabra(Comienzo) <> "," Then AddError 23, False, "','"
      Comienzo = Comienzo + 1
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "rndint"
      ToFileInt 15260
      If Palabra(Comienzo + 1) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 2
      Expression Comienzo
      If Palabra(Comienzo) <> "," Then AddError 23, False, "','"
      Comienzo = Comienzo + 1
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case "int"
      ToFileInt 15270
      If Palabra(Comienzo + 1) <> "(" Then AddError 23, False, "'('"
      Comienzo = Comienzo + 2
      Expression Comienzo
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    Case Else
      If Left$(Palabra(Comienzo), 1) = """" Then
        ToFileInt 17100
        ToFileInt AddString(NoQuotes(Palabra(Comienzo)))
      ElseIf IsNumeric(Palabra(Comienzo)) Then
        ToFileInt 17200
        If Palabra(Comienzo + 1) = "." Then
          If Not IsNumeric(Palabra(Comienzo + 2)) Then AddError 0, False
          ToFileDbl Val(Palabra(Comienzo) & "." & Palabra(Comienzo + 2))
          Comienzo = Comienzo + 2
        Else
          ToFileDbl Val(Palabra(Comienzo))
        End If
      ElseIf IsVarRef(Palabra(Comienzo)) Then
        ToFileInt 17300
        If Not IsTipoIntrin(AnalizarTipo(Comienzo, True, Limite)) Then AddError 9, False
        If Limite Then AddError 26, False
        Exit Sub
      ElseIf MethodAnalyze(Comienzo) Then
        Exit Sub
      ElseIf FuncAnalyze(Comienzo) Then
        Exit Sub
      ElseIf PropAnalyze(Comienzo, True) Then
        Exit Sub
      Else
        AddError 23, False, "Expression"
      End If
  End Select
  Comienzo = Comienzo + 1
End Sub
