Attribute VB_Name = "modLabels"
Option Explicit
Type LABELDATA
  Line As Long
  Position As Long
  Nomb As String
End Type
Dim Labels() As LABELDATA
Dim MaxLabel As Long

Function LabelAdm(ByVal Action As Long, Optional ByVal LabelId As Long, Optional Nomb As String) As Long
  Dim i As Long

  Select Case Action
    Case 0 'new label
      ReDim Preserve Labels(MaxLabel)
      With Labels(MaxLabel)
        .Line = CurLine
        .Position = -1
        .Nomb = Nomb
      End With
      LabelAdm = MaxLabel
      MaxLabel = MaxLabel + 1
    Case 1 'define label
      Labels(LabelId).Position = Seek(1) - 1
    Case 2 'new defined label
      LabelAdm = LabelAdm(0, , Nomb)
      Labels(LabelAdm).Position = Seek(1) - 1
    Case 3 'flush
      Put 1, , MaxLabel
      For i = 0 To MaxLabel - 1
        With Labels(i)
          If .Position = -1 Then
            CurLine = .Line
            AddError 22, False
          End If
          Put 1, , .Position
        End With
      Next i
    Case 4 'find
      For i = 0 To MaxLabel - 1
        If LCase$(Labels(i).Nomb) = LCase$(Nomb) Then
          LabelAdm = i
          Exit Function
        End If
      Next i
      LabelAdm = -1
    Case 5 'find defined
      For i = 0 To MaxLabel - 1
        With Labels(i)
          If .Position <> -1 And LCase$(.Nomb) = LCase$(Nomb) Then
            LabelAdm = i
            Exit Function
          End If
        End With
      Next i
      LabelAdm = -1
  End Select
End Function

Sub InitializeLabels()
  Erase Labels
  MaxLabel = 0
End Sub
