Attribute VB_Name = "modCtrls"
Option Explicit
Type CTRLDATA
  KindOf As Byte
  Line As Long
  ExitLabel As Long
  InfLng1 As Long
  InfLng2 As Long
  InfBool1 As Boolean
  InfBool2 As Boolean
End Type
Public Ctrls() As CTRLDATA
Dim MaxCtrl As Long
Public Const eIf = 1, eElseIf = 2, eDo = 3, eFor = 4, eSel = 5

Function CtrlAdm(ByVal Action As Long, Optional ByVal KindOf1 As Byte, Optional ByVal KindOf2 As Byte) As Long
  Dim i As Long

  Select Case Action
    Case 0 'new
      ReDim Preserve Ctrls(MaxCtrl)
      With Ctrls(MaxCtrl)
        .KindOf = KindOf1
        .Line = CurLine
        .ExitLabel = LabelAdm(0)
      End With
      CtrlAdm = MaxCtrl
      MaxCtrl = MaxCtrl + 1
    Case 1 'remove
      MaxCtrl = MaxCtrl - 1
      LabelAdm 1, Ctrls(MaxCtrl).ExitLabel
      If MaxCtrl Then ReDim Preserve Ctrls(MaxCtrl - 1) Else Erase Ctrls
    Case 2 'find
      For i = MaxCtrl - 1 To 0 Step -1
        With Ctrls(i)
          If .KindOf = KindOf1 Or (KindOf2 <> 0 And .KindOf = KindOf2) Then
            CtrlAdm = i
            Exit Function
          End If
        End With
      Next i
      CtrlAdm = -1
    Case 3 'last ctrl
      If MaxCtrl Then
        With Ctrls(MaxCtrl - 1)
          If .KindOf = KindOf1 Or (KindOf2 <> 0 And .KindOf = KindOf2) Then
            CtrlAdm = MaxCtrl - 1
            Exit Function
          End If
        End With
      End If
      CtrlAdm = -1
    Case 4 'check
      If MaxCtrl = 0 Then Exit Function
      With Ctrls(MaxCtrl - 1)
        CurLine = .Line
        Select Case .KindOf
          Case eIf, eElseIf
            AddError 12, False
          Case eDo
            AddError 15, False
          Case eFor
            AddError 17, False
        End Select
      End With
  End Select
End Function

Sub InitializeCtrls()
  Erase Ctrls
  MaxCtrl = 0
End Sub

